<?php
/*
 * COMPARISON (http://www.comparison.jp/prod/)
 * Copyright (C) 2006 EWA
 */

require_once('CPRDEF.php');
require_once('HTML/QuickForm.php');


class CPRAUTH {
	
	#Update authenticate information
	function action_modacct(){
		global $o_smarty;
		
		#Build a form
		$o_form=new HTML_QuickForm('modacct','post',_BASEACTIONURL.'?action=modacct');
		$o_form->registerRule('checkpasswd','callback','checkpasswd');
		$o_form->addElement('text',		'newuname',		_FORM_AUTH_NEWUNAME,	array('size'=>30));
		$o_form->addElement('password',	'newupasswd',	_FORM_AUTH_NEWUPASSWD,	array('size'=>30));
		$o_form->addElement('password',	'oldupasswd',	_FORM_AUTH_OLDPASSWD,	array('size'=>30));
		$o_form->addElement('submit',	NULL,			_FORM_AUTH_SUBMIT);
		$o_form->addRule('newuname',	_FORM_RULE_TOOLONG,'maxlength',48);
		$o_form->addRule('newupasswd',	_FORM_RULE_TOOLONG,'maxlength',40);
		$o_form->addRule('oldupasswd',	_FORM_RULE_TOOLONG,'maxlength',40);
		$o_form->addRule('newuname',	_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('oldupasswd',	_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('oldupasswd',	_FORM_RULE_WRONGPASSWD,'checkpasswd');

		#This uname will be used for updating data, even unchanged.
		$o_form->setDefaults(array(
			'newuname'    => $this->getuname(),
			));

		if($o_form->validate()){
			$a_rest=$o_form->exportValues();
			
			#If validated, update table
			if($a_rest['newupasswd']==''){
				$this->updateauth($this->getuid(),$a_rest['newuname']);
			}else{
				$this->updateauth($this->getuid(),$a_rest['newuname'],$a_rest['newupasswd']);
			}
			redirect(_BASEACTIONURL.'?action=modacct');
			exit;
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()
				));
			$o_smarty->display('modacct.tmpl.html');
			exit;
		}
	}
	
	function action_logout(){
		if($this->checkauth()){
			$v_uid=$this->getuid();
		}else{
			$v_uid=FALSE;
		}
		
		if($v_uid!==FALSE){
			#REVOKEする
			setcookie('id','NULL',-1);
			setcookie('ck','NULL',-1);
			
			mt_srand(microtime()*100000);
			$v_query='update '._DBPREFIX.'user set ucookie=? where uid=?';
			$o_query=db_query($v_query,array(sha1(uniqid(mt_rand(),1)),$v_uid));
		}
		redirect(_BASEACTIONURL);
		exit;
	}

	function updateauth($v_uid,$v_uname,$v_upasswd=FALSE){
		if($v_upasswd===FALSE){
			$v_query='update '._DBPREFIX.'user set uname=? where uid=?';
			$o_query=db_query($v_query,array($v_uname,$v_uid));
		}else{
			$v_query='update '._DBPREFIX.'user set uname=?,upasswd=? where uid=?';
			$o_query=db_query($v_query,array($v_uname,sha1($v_upasswd),$v_uid));
		}
		return true;
	}
	
	function getuname(){
		if($this->checkauth()){
			$v_cookieid=getcookienum('id');
			$v_query='select * from '._DBPREFIX.'user where uid=?';
			$o_query=db_query($v_query,array($v_cookieid));
			$a_query=db_fetch_assoc($o_query);
			return $a_query[0]['uname'];
		}
	}
	
	function getuid(){
		if($this->checkauth()){
			return getcookienum('id');
		}
	}

	function login(){
		global $o_smarty;

		#CREATE URL TO REDIRECT
		if(isset($_GET['action'])){
			$v_action = _BASEACTIONURL.'?'.'action='.$_GET['action'];
			foreach($_GET as $v_key=>$v_val){if($v_key!='action'){$v_action.='&'.$v_key.'='.$v_val;}}
		}else{
			$v_action=_BASEACTIONURL;
		}

		$o_form=new HTML_QuickForm('auth','post',$v_action);
		$this->buildauthform($o_form);

		if($o_form->validate()){
			$v_expire=time()+60*60*24*90;
			$a_rest  =$o_form->exportValues();
			$a_user  =$this->select_user($a_rest['uname'],$a_rest['upasswd']);
			$v_cookie=$this->setusercookie($a_user['uid']);
			$b_cookie_id=setcookie('id',$a_user['uid'],$v_expire);
			$b_cookie_pw=setcookie('ck',$v_cookie,$v_expire);
			redirect($v_action);
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()
				));
			$o_smarty->display('login.tmpl.html');
			exit;
		}
		
	}
	
	function checkauth(){
		if(isset($_COOKIE['id']) && isset($_COOKIE['ck'])){
			$b_auth=$this->select_auth(getalphanumericvals('id'),getcookiealphanumeric('ck'));
			return $b_auth;
		}else{
			return false;
		}
	}
	
	function doauth(){
		$b_auth=$this->checkauth();
		if($b_auth!==true){
			$this->login();
		}else{
			return true;
		}
	}
	
	function select_auth($v_uid,$v_ucookie){
		$v_query = 'select * from '._DBPREFIX.'user where uid=? and ucookie=?';
		$o_query = db_query($v_query,array($v_uid,$v_ucookie));
		$a_query = db_fetch_assoc($o_query);
		if(count($a_query)>=1){
			return true;
		}else{
			return false;
		}
	}
	
	function setusercookie($v_uid){
		mt_srand(microtime()*100000);
		$v_cookie=sha1(uniqid(mt_rand(),1));
		$v_query='update '._DBPREFIX.'user set ucookie=? where uid=?';
		db_query($v_query,array($v_cookie,$v_uid));
		return $v_cookie;
	}
	
	function buildauthform(&$o_form){
		
		$o_form->addElement('text',		'uname',	_FORM_AUTH_UNAME);
		$o_form->addElement('password',	'upasswd',	_FORM_AUTH_UPASSWD);
		$o_form->addElement('submit',	NULL,		_FORM_AUTH_SUBMIT);
		
		$o_form->addRule('uname',	_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('upasswd',	_FORM_RULE_REQUIRED,'required');
		
		$o_form->addRule('uname',	_FORM_RULE_ALPHANUMERIC,'alphanumeric');
		$o_form->addRule('upasswd',	_FORM_RULE_ALPHANUMERIC,'alphanumeric');

		$o_form->addRule('uname',	_FORM_RULE_TOOLONG,'maxlength',48);
		$o_form->addRule('upasswd',	_FORM_RULE_TOOLONG,'maxlength',40);

		$o_form->addFormRule('authentication');
	}
	
	function select_user($v_uname,$v_upasswd){
		$v_query_p='select * from '._DBPREFIX.'user where uname=? and upasswd=?';
		$o_query_p=db_query($v_query_p,array($v_uname,sha1($v_upasswd)));
		$a_query_p=db_fetch_assoc($o_query_p);
		return $a_query_p[0];
	}

}

function authentication($a_data){
	
	#CHECK USER EXISTENCE
	$v_query_u='select * from '._DBPREFIX.'user where uname=?';
	$o_query_u=db_query($v_query_u,$a_data['uname']);
	$a_query_u=db_fetch_assoc($o_query_u);
	if(count($a_query_u)===0){return array('uname'=>_FORM_RULE_USERNAMEEXISTENCE);}
	
	#CHECK PASSWORD
	$v_query_p='select * from '._DBPREFIX.'user where uname=? and upasswd=?';
	$o_query_p=db_query($v_query_p,array($a_data['uname'],sha1($a_data['upasswd'])));
	$a_query_p=db_fetch_assoc($o_query_p);
	if(count($a_query_p)===0){
		return array('upasswd'=>_FORM_RULE_WRONGPASSWD);
	}else{
		return true;
	} 
	exit;
}

function checkpasswd($v_upasswd){
	$v_uid=intval($_COOKIE['id']);
	$v_query_p='select * from '._DBPREFIX.'user where uid=? and upasswd=?';
	$o_query_p=db_query($v_query_p,array($v_uid,sha1($v_upasswd)));
	$a_query_p=db_fetch_assoc($o_query_p);
	if(count($a_query_p)>=1){return true;}else{return false;}
}

?>