<?php
/*
 * COMPARISON (http://www.comparison.jp/prod/)
 * Copyright (C) 2006 EWA
 */
require_once('CPRDEF.php');
require_once('CPRBASE.php');
require_once('HTML/QuickForm.php');

class CPRCAT extends CPRBASE{
	
	#Create new cat
	function action_cat_new(){
		global $o_smarty;
		
		$o_form=new HTML_QuickForm('createcat','post',_BASEACTIONURL.'?action=createcat');
		$this->buildcatform($o_form);
		
		#Additional rules
		$o_form->registerRule('rule_cname_e_unique','callback','rule_cname_e_unique');
		$o_form->addRule('cname_e',_FORM_RULE_UNIQUE,'rule_cname_e_unique');			#cname_eの一意性を確認
		
		if($o_form->validate()){
			$a_rest=$o_form->exportValues();
			$this->insertcat($a_rest);
			redirect(_BASEACTIONURL.'?action=showcatlist');
			exit;
		}else{
			$o_smarty->assign(array('form'=>$o_form->tohtml()));
			$o_smarty->display('catmodify.tmpl.html');
			exit;
		}
	}
	
	#Delete cat
	function action_cat_del(){
		global $o_smarty;
		
		$v_cid=getnumvals('cid');
		if(!$this->check_cid_existense($v_cid)){error_user(_MSG_ERROR_NOCAT,TRUE);}
		
		$o_form=new HTML_QuickForm('delcat','post',_BASEACTIONURL.'?action=delcat&cid='.$v_cid);
		$o_form->addElement('submit','submit',_FORM_GEN_SUBMIT);
		
		if($o_form->validate()){
			$v_query='delete from '._DBPREFIX.'cat where cid=?';
			db_query($v_query,$v_cid);
			redirect(_BASEACTIONURL.'?action=showcatlist');
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()
				));
			$o_smarty->display('confirmdelcat.tmpl.html');
			exit;
		}
	}
	
	#Edit cat
	function action_cat_edit(){
		global $o_smarty;
		
		$v_cid=getnumvals('cid');
		if(!$this->check_cid_existense($v_cid)){error_user(_MSG_ERROR_NOCAT,TRUE);}
		
		$o_form=new HTML_QuickForm('editcat','post',_BASEACTIONURL.'?action=editcat');
		$this->buildcatform($o_form);
		
		$a_cat   = $this->select_cid($v_cid);
		//[TODO]カテゴリが存在しない場合の処理
		
		#Additional elements and rules for editing the cat
		$o_form->addElement('hidden','cid',$a_cat['cid']);
		$o_form->registerRule('rule_cname_e_unique_edit','callback','rule_cname_e_unique_edit');
		$o_form->addRule('cname_e',_FORM_RULE_UNIQUE,'rule_cname_e_unique_edit',$v_cid);			#cname_eの一意性を確認
		
		#Set defaults
		$o_form->setDefaults(array(
			'cname_j'=>$a_cat['cname_j'],
			'cname_e'=>$a_cat['cname_e'],
			'cdesc_s'=>$a_cat['cdesc_s'],
			'cdesc_l'=>$a_cat['cdesc_l'],
			'cparent'=>$a_cat['cparent'],
			));

		if($o_form->validate()){
			$a_rest=$o_form->exportValues();
			$this->updatecat($a_rest);
			redirect(_BASEACTIONURL.'?action=showcatlist');
			exit;
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()					#フォームを作成してSMARTYへ渡す
				));
			$o_smarty->display('catmodify.tmpl.html');
			exit;
		}
		
	}
	
	#Display cat
	function action_cat_show(){
		global $o_smarty;

		#Setting parent cat to each cat
		$a_catlist=$this->select_cat();
		for($i=0;isset($a_catlist[$i]);$i++){
			if($a_catlist[$i]['cparent']==='0'){			#Ignore top cat
				$a_catlist[$i]['parent']=false;				#Set false for top cat
			}else{
				$a_catlist[$i]['parent']=$this->select_cid($a_catlist[$i]['cparent']);
			}
		}
		
		$o_smarty->assign(array(
			'catlist'=>$a_catlist
			));
		$o_smarty->display('catlist.tmpl.html');
		exit;
	}
	
	#
	# SQL
	#
	
	function updatecat($a_data){
		$v_query   = 'update '._DBPREFIX.'cat set cname_j=?,cname_e=?,cdesc_s=?,cdesc_l=?,cparent=? where cid=?';
		$a_prepare = array($a_data['cname_j'],$a_data['cname_e'],$a_data['cdesc_s'],$a_data['cdesc_l'],$a_data['cparent'],$a_data['cid']);
		db_query($v_query,$a_prepare);
	}
	
	function insertcat($a_data){
		$v_query   = 'insert into '._DBPREFIX.'cat (cname_j,cname_e,cdesc_s,cdesc_l,cparent) values (?,?,?,?,?)';
		$a_prepare = array($a_data['cname_j'],$a_data['cname_e'],$a_data['cdesc_s'],$a_data['cdesc_l'],$a_data['cparent']);
		db_query($v_query,$a_prepare);
	}
	
	#
	# FORM
	#
	
	function buildcatform(&$o_form){
		#事前準備
		$a_cat_title=array('0'=>_FORM_CAT_TOP);
		$a_listcat=$this->select_cparent(0);
		foreach($a_listcat as $a_listcat_t){
			$a_cat_title[$a_listcat_t['cid']] = $a_listcat_t['cname_j'];
		}

		#フォーム作成
		$o_form->addElement('text',		'cname_j',	_FORM_CAT_CNAME_J,	array('size'=>50));
		$o_form->addElement('text',		'cname_e',	_FORM_CAT_CNAME_E,	array('size'=>50));
		$o_form->addElement('textarea',	'cdesc_s',	_FORM_CAT_CDESC_S,	array('rows'=>5,'cols'=>50));
		$o_form->addElement('textarea',	'cdesc_l',	_FORM_CAT_CDESC_L,	array('rows'=>5,'cols'=>50));
		$o_form->addElement('select',	'cparent',	_FORM_CAT_PARENT,$a_cat_title);
		$o_form->addElement('submit',	NULL,		_FORM_CAT_SUBMIT);
		
		#ルール追加
		//[TODO]カテゴリの存在を確認するカスタムルール
		$o_form->addRule('cname_j',_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('cname_e',_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('cparent',_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('cname_j',_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('cname_e',_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('cdesc_s',_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('cdesc_l',_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('cname_e',_FORM_RULE_ALPHANUMERIC,'alphanumeric');		#cname_eはフォルダ名で使用するためalphanumeric
	}
		
	
}

#
# RULES
#

function rule_cname_e_unique($v_data){
	$o_base=new CPRBASE();
	return $o_base->check_cname_e_existense($v_data);
}

function rule_cname_e_unique_edit($v_data,$v_cid){
	$o_base=new CPRBASE();
	$a_query = $o_base->select_cname_e_raw($v_data);
	
	if(count($a_query)==0){
		return true;
	}elseif(count($a_query)==1 && $a_query[0]['cid']==$v_cid){
		return true;
	}else{
		return false;
	}
}

?>
