<?php
/*
 * COMPARISON (http://www.comparison.jp/prod/)
 * Copyright (C) 2006 EWA
 */
require_once('CPRDEF.php');
require_once('CPRBASE.php');
require_once('HTML/QuickForm.php');

class CPRENTRY extends CPRBASE{
	
	#NEW ENTRY
	function action_entry_new(){
		global $o_smarty;
		
		$o_form=new HTML_QuickForm('createentry','post',_BASEACTIONURL.'?action=createentry');
		$this->buildentryform($o_form);

		#Additional form rules for new entry
		$o_form->registerRule('rule_ename_e_unique','callback','rule_ename_e_unique');
		$o_form->addRule('ename_e',_FORM_RULE_UNIQUE,'rule_ename_e_unique');			#ename_eの一意性を確認

		if($o_form->validate()){
			$a_rest=$o_form->exportValues();
			$this->insertentry($a_rest);
			redirect(_BASEACTIONURL.'?action=showentrylist');
			exit;
		}else{
			$o_smarty->assign(array('form'=>$o_form->tohtml()));
			$o_smarty->display('entrymodify.tmpl.html');
			exit;
		}
	}
	
	function action_entry_edit(){
		global $o_smarty;
		
		$v_eid=getnumvals('eid');
		if(!$this->check_eid_existense($v_eid)){error_user(_MSG_ERROR_NOENTRY,TRUE);}
		
		$o_form=new HTML_QuickForm('editentry','post',_BASEACTIONURL.'?action=editentry');
		$this->buildentryform($o_form);

		$a_entry = $this->select_eid($v_eid);
		if($a_entry===FALSE){error_user(_MSG_ERROR_NOENTRY,TRUE);}
		
		#Additional form elements and rules for editing the entry
		$o_form->addElement('hidden','eid',$a_entry['eid']);
		$o_form->registerRule('rule_ename_e_unique_edit','callback','rule_ename_e_unique_edit');
		$o_form->addRule('ename_e',_FORM_RULE_UNIQUE,'rule_ename_e_unique_edit',$v_eid);			#cname_eの一意性を確認

		$o_form->setDefaults(array(
			'ename_j'    => $a_entry['ename_j'],
			'ename_e'    => $a_entry['ename_e'],
			'etextlink'  => $a_entry['etextlink'],
			'eimagelink' => $a_entry['eimagelink'],
			'edesc_s'    => $a_entry['edesc_s'],
			'edesc_l'    => $a_entry['edesc_l'],
			'erating'    => $a_entry['erating'],
			'estar'	     => $a_entry['estar'],
			'elogo'      => $a_entry['elogo'],
			'escreenshot'=> $a_entry['escreenshot'],
			'ecat'       => $a_entry['ecat'],
			));

		if($o_form->validate()){
			$a_rest=$o_form->exportValues();
			$this->updateentry($a_rest);
			redirect(_BASEACTIONURL.'?action=showentrylist');
			exit;
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()					#フォームを作成してSMARTYへ渡す
				));
			$o_smarty->display('entrymodify.tmpl.html');
			exit;
		}
		
	}
	
	function action_entry_del(){
		global $o_smarty;
		
		$v_eid=getnumvals('eid');
		if(!$this->check_eid_existense($v_eid)){error_user(_MSG_ERROR_NOENTRY,TRUE);}

		$o_form=new HTML_QuickForm('delentry','post',_BASEACTIONURL.'?action=delentry&eid='.$v_eid);
		$o_form->addElement('submit','submit',_FORM_GEN_SUBMIT);
		
		if($o_form->validate()){
			$v_query='delete from '._DBPREFIX.'entry where eid=?';
			db_query($v_query,$v_eid);
			redirect(_BASEACTIONURL.'?action=showentrylist');
		}else{
			$o_smarty->assign(array(
				'form'=>$o_form->tohtml()
				));
			$o_smarty->display('confirmdelentry.tmpl.html');
			exit;
		}
	}
	
	function action_entry_show(){
		global $o_smarty;

		$a_entries=$this->select_entry();
		for($i=0;isset($a_entries[$i]);$i++){
			$a_entries[$i]['cat']=$this->select_cid($a_entries[$i]['ecat']);
		}
		
		$o_smarty->assign(array(
			'entrylist'=>$a_entries
			));
		$o_smarty->display('entrylist.tmpl.html');
		exit;
	}
	
	#
	# SQL
	#
	
	function updateentry($a_data){
		$v_query   = 'update '._DBPREFIX.'entry set ename_j=?,ename_e=?,etextlink=?,eimagelink=?,edesc_s=?,edesc_l=?,erating=?,estar=?,elogo=?,escreenshot=?,ecat=? where eid=?';
		$a_prepare = array($a_data['ename_j'],$a_data['ename_e'],$a_data['etextlink'],$a_data['eimagelink'],$a_data['edesc_s'],$a_data['edesc_l'],$a_data['erating'],$a_data['estar'],$a_data['elogo'],$a_data['escreenshot'],$a_data['ecat'],$a_data['eid']);
		db_query($v_query,$a_prepare);
	}
	
	function insertentry($a_data){
		$v_query   = 'insert into '._DBPREFIX.'entry (ename_j,ename_e,etextlink,eimagelink,edesc_s,edesc_l,erating,estar,elogo,escreenshot,ecat) values (?,?,?,?,?,?,?,?,?,?,?)';
		$a_prepare = array($a_data['ename_j'],$a_data['ename_e'],$a_data['etextlink'],$a_data['eimagelink'],$a_data['edesc_s'],$a_data['edesc_l'],$a_data['erating'],$a_data['estar'],$a_data['elogo'],$a_data['escreenshot'],$a_data['ecat']);
		db_query($v_query,$a_prepare);
	}
	
	#
	# FORM
	#
	
	function buildentryform(&$o_form){
		
		#Prepare
		$a_cat_title=array();
		$a_cat_value=array();
		$a_listcat=$this->select_cparent_not(0);
		foreach($a_listcat as $a_listcat_t){
			$a_cat_title[$a_listcat_t['cid']] = $a_listcat_t['cname_j'];
		}
		
		#Make array for estar
		$a_star=array(1=>1,2=>2,3=>3,4=>4,5=>5,6=>6,7=>7,8=>8,9=>9,10=>10);

		#Register rule
		$o_form->registerRule('rule_ecat_existene','callback','rule_ecat_existene');

		#Create form elements
		$o_form->addElement('text',		'ename_j',		_FORM_ENTRY_NAME_J,		array('size'=>50));
		$o_form->addElement('text',		'ename_e',		_FORM_ENTRY_NAME_E,		array('size'=>50));
		$o_form->addElement('textarea',	'etextlink',	_FORM_ENTRY_TEXTLINK,	array('rows'=>5,'cols'=>50));
		$o_form->addElement('textarea',	'eimagelink',	_FORM_ENTRY_IMGLINK,	array('rows'=>5,'cols'=>50));
		$o_form->addElement('textarea',	'edesc_s',		_FORM_ENTRY_DESC_S,		array('rows'=>5,'cols'=>50));
		$o_form->addElement('textarea',	'edesc_l',		_FORM_ENTRY_DESC_L,		array('rows'=>10,'cols'=>50));
		$o_form->addElement('text',		'elogo',		_FORM_ENTRY_LOGO,		array('size'=>50));
		$o_form->addElement('text',		'escreenshot',	_FORM_ENTRY_SCREENSHOT,	array('size'=>50));
		$o_form->addElement('text',		'erating',		_FORM_ENTRY_RATING,		array('size'=>50));
		$o_form->addElement('select',	'ecat',			_FORM_ENTRY_CAT,		$a_cat_title);
		$o_form->addElement('select',	'estar',		_FORM_ENTRY_STAR,		$a_star);
		$o_form->addElement('submit',	NULL,			_FORM_ENTRY_SUBMIT);
		
		#Adding rules
		//[TODO]カテゴリの存在を確認するカスタムルール
		$o_form->addRule('ename_j',		_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('ename_e',		_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('ecat',		_FORM_RULE_REQUIRED,'required');
		$o_form->addRule('ename_j',		_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('ename_e',		_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('etextlink',	_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('eimagelink',	_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('edesc_s',		_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('edesc_l',		_FORM_RULE_TOOLONG,'maxlength',65533);
		$o_form->addRule('elogo',		_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('escreenshot',	_FORM_RULE_TOOLONG,'maxlength',254);
		$o_form->addRule('erating',		_FORM_RULE_NUMERIC,'numeric');
		$o_form->addRule('estar',		_FORM_RULE_NUMERIC,'numeric');
		$o_form->addRule('erating',		_FORM_RULE_TOOLONG,'maxlength',4);
		$o_form->addRule('cname_e',		_FORM_RULE_ALPHANUMERIC,'alphanumeric');			#cname_eはフォルダ名で使用するためalphanumeric
		$o_form->addRule('ecat',		_FORM_RULE_CATIDEXISTENCE,'rule_ecat_existene');
	}
}

#
# FORM RULES
#

function rule_ecat_existene($v_data){
	$o_base=new CPRBASE();
	return $o_base->check_cid_existense($v_data);
}

function rule_ename_e_unique($v_data){
	$o_base=new CPRBASE();
	return $o_base->check_ename_existense($v_data);
}

function rule_ename_e_unique_edit($v_data,$v_eid){
	$o_base=new CPRBASE();
	$a_query = $o_base->select_cat_raw($v_data);
	
	#See if array is empty or eid is same as the entry being edited
	if(count($a_query)==0){
		return true;
	}elseif(count($a_query)==1 && $a_query[0]['eid']==$v_eid){
		return true;
	}else{
		return false;
	}
}

?>
